searchNodes=[{"doc":"Ethereumex Elixir JSON-RPC client for the Ethereum blockchain Check out the documentation here. Installation Add Ethereumex to your mix.exs dependencies: Add ethereumex to your list of dependencies in mix.exs: def deps do [{:ethereumex, &quot;~&gt; 0.6.1&quot;}] end Ensure ethereumex is started before your application: def application do [applications: [:ethereumex]] end Configuration In config/config.exs, add Ethereum protocol host params to your config file config :ethereumex, url: &quot;http://localhost:8545&quot; You can also configure the HTTP request timeout for requests sent to the Ethereum JSON-RPC (you can also overwrite this configuration in opts used when calling the client): config :ethereumex, http_options: [timeout: 8000, recv_timeout: 5000] :timeout - timeout to establish a connection, in milliseconds. Default is 8000 :recv_timeout - timeout used when receiving a connection. Default is 5000 If you want to use IPC you will need to set a few things in your config. First, specify the :client_type: config :ethereumex, client_type: :ipc This will resolve to :http by default. Second, specify the :ipc_path: config :ethereumex, ipc_path: &quot;/path/to/ipc&quot; If you want to count the number of RPC calls per RPC method or overall, you can attach yourself to executed telemetry events. There are two events you can attach yourself to: [:ethereumex] # has RPC method name in metadata Emitted event: {:event, [:ethereumex], %{counter: 1}, %{method_name: &quot;method_name&quot;}} or more granular [:ethereumex, &lt;rpc_method&gt;] # %{} metadata Emitted event: {:event, [:ethereumex, :method_name_as_atom], %{counter: 1}, %{}} Each event caries a single ticker that you can pass into your counters (like Statix.increment/2). Be sure to add :telemetry as project dependency. The IPC client type mode opens a pool of connection workers (default is 5 and 2, respectively). You can configure the pool size. config :ethereumex, ipc_worker_size: 5, ipc_max_worker_overflow: 2, ipc_request_timeout: 60_000 Usage Available methods: web3_clientVersion web3_sha3 net_version net_peerCount net_listening eth_protocolVersion eth_syncing eth_coinbase eth_mining eth_hashrate eth_gasPrice eth_accounts eth_blockNumber eth_getBalance eth_getStorageAt eth_getTransactionCount eth_getBlockTransactionCountByHash eth_getBlockTransactionCountByNumber eth_getUncleCountByBlockHash eth_getUncleCountByBlockNumber eth_getCode eth_sign eth_sendTransaction eth_sendRawTransaction eth_call eth_estimateGas eth_getBlockByHash eth_getBlockByNumber eth_getTransactionByHash eth_getTransactionByBlockHashAndIndex eth_getTransactionByBlockNumberAndIndex eth_getTransactionReceipt eth_getUncleByBlockHashAndIndex eth_getUncleByBlockNumberAndIndex eth_getCompilers eth_compileLLL eth_compileSolidity eth_compileSerpent eth_newFilter eth_newBlockFilter eth_newPendingTransactionFilter eth_uninstallFilter eth_getFilterChanges eth_getFilterLogs eth_getLogs eth_getProof eth_getWork eth_submitWork eth_submitHashrate db_putString db_getString db_putHex db_getHex shh_post shh_version shh_newIdentity shh_hasIdentity shh_newGroup shh_addToGroup shh_newFilter shh_uninstallFilter shh_getFilterChanges shh_getMessages IpcClient You can follow along with any of these examples using IPC by replacing HttpClient with IpcClient. Examples iex&gt; Ethereumex.HttpClient.web3_client_version {:ok, &quot;Parity//v1.7.2-beta-9f47909-20170918/x86_64-macos/rustc1.19.0&quot;} # Using the url option will overwrite the configuration iex&gt; Ethereumex.HttpClient.web3_client_version(url: &quot;http://localhost:8545&quot;) {:ok, &quot;Parity//v1.7.2-beta-9f47909-20170918/x86_64-macos/rustc1.19.0&quot;} iex&gt; Ethereumex.HttpClient.web3_sha3(&quot;wrong_param&quot;) {:error, %{&quot;code&quot; =&gt; -32602, &quot;message&quot; =&gt; &quot;Invalid params: invalid format.&quot;}} iex&gt; Ethereumex.HttpClient.eth_get_balance(&quot;0x407d73d8a49eeb85d32cf465507dd71d507100c1&quot;) {:ok, &quot;0x0&quot;} Note that all method names are snakecases, so, for example, shh_getMessages method has corresponding Ethereumex.HttpClient.shh_get_messages/1 method. Signatures can be found in Ethereumex.Client.Behaviour. There are more examples in tests. eth_call example - Read only smart contract calls In order to call a smart contract using the JSON-RPC interface you need to properly hash the data attribute (this will need to include the contract method signature along with arguments if any). You can do this manually or use a hex package like (ABI)[https://github.com/exthereum/abi] to parse your smart contract interface or encode individual calls. defp deps do [ ... {:ethereumex, &quot;~&gt; 0.4.0&quot;}, {:abi, &quot;~&gt; 0.1.8&quot;} ... ] end Now load the abi and pass the method signature. Note that the address needs to be converted to bytes address = &quot;0x123&quot; |&gt; String.slice(2..-1) |&gt; Base.decode16(case: :mixed) contract_address = &quot;0x432&quot; abi_encoded_data = ABI.encode(&quot;balanceOf(address)&quot;, [address]) |&gt; Base.encode16(case: :lower) Now you can use eth_call to execute this smart contract command: balance_bytes = Ethereumex.HttpClient.eth_call(%{ data: &quot;0x&quot; &lt;&gt; abi_encoded_data, to: contract_address }) To convert the balance into an integer: balance_bytes |&gt; String.slice(2..-1) |&gt; Base.decode16!(case: :lower) |&gt; TypeDecoder.decode_raw([{:uint, 256}]) |&gt; List.first eth_send_raw_transaction example - Payable smart contract call Calling a smart contract method that requires computation will cost you gas or ether (if that method requires payment also). This means you will have to sign your transactions using the private key that owns some ethereum. In order to send signed transactions you will need both ABI and Blockchain hex packages. abi_encoded_data = ABI.encode(&quot;transferFrom(address,address,uint)&quot;, [from_address, to_address, token_id]) contract_address = &quot;0x123&quot; |&gt; String.slice(2..-1) |&gt; Base.decode16(case: :mixed) transaction_data = %Blockchain.Transaction{ data: abi_encoded_data, gas_limit: 100_000, gas_price: 16_000_000_000, init: &lt;&lt;&gt;&gt;, nonce: 5, to: contract_address, value: 0 } |&gt; Blockchain.Transaction.Signature.sign_transaction(private_key) |&gt; Blockchain.Transaction.serialize() |&gt; ExRLP.encode() |&gt; Base.encode16(case: :lower) Ethereumex.HttpClient.eth_send_raw_transaction(&quot;0x&quot; &lt;&gt; transaction_data) Custom requests Many Ethereum protocol implementations support additional JSON-RPC API methods. To use them, you should call Ethereumex.HttpClient.request/3 method. For example, let&#39;s call parity&#39;s personal_listAccounts method. iex&gt; Ethereumex.HttpClient.request(&quot;personal_listAccounts&quot;, [], []) {:ok, [&quot;0x71cf0b576a95c347078ec2339303d13024a26910&quot;, &quot;0x7c12323a4fff6df1a25d38319d5692982f48ec2e&quot;]} Batch requests To send batch requests use Ethereumex.HttpClient.batch_request/1 method. requests = [ {:web3_client_version, []}, {:net_version, []}, {:web3_sha3, [&quot;0x68656c6c6f20776f726c64&quot;]} ] Ethereumex.HttpClient.batch_request(requests) { :ok, [ &quot;Parity//v1.7.2-beta-9f47909-20170918/x86_64-macos/rustc1.19.0&quot;, &quot;42&quot;, &quot;0x47173285a8d7341e5e972fc677286384f802f8ef42a5ec5f03bbfa254cb01fad&quot; ] } Built on Ethereumex If you are curious what others are building with ethereumex, you might want to take a look at these projects: exw3 - A high-level contract abstraction and other goodies similar to web3.js eth - Ethereum utilities for Elixir. eth_contract - A set of helper methods for calling ETH Smart Contracts via JSON RPC. Contributing Fork it! Create your feature branch (git checkout -b my-new-feature) Commit your changes (git commit -am &#39;Add some feature&#39;) Push to the branch (git push origin my-new-feature) Create new Pull Request Author Ayrat Badykov (@ayrat555) License Ethereumex is released under the MIT License.","ref":"Ethereumex.html","title":"Ethereumex","type":"module"},{"doc":"Callback implementation for Application.start/2.","ref":"Ethereumex.html#start/2","title":"Ethereumex.start/2","type":"function"},{"doc":"The Base Client exposes the Ethereum Client RPC functionality. We use a macro so that exposed functions can be used in different behaviours (HTTP or IPC).","ref":"Ethereumex.Client.BaseClient.html","title":"Ethereumex.Client.BaseClient","type":"module"},{"doc":"An application wide RPC2Ethereum client request counter.","ref":"Ethereumex.Counter.html","title":"Ethereumex.Counter","type":"module"},{"doc":"","ref":"Ethereumex.Counter.html#get/1","title":"Ethereumex.Counter.get/1","type":"function"},{"doc":"","ref":"Ethereumex.Counter.html#increment/2","title":"Ethereumex.Counter.increment/2","type":"function"},{"doc":"","ref":"Ethereumex.Counter.html#increment/3","title":"Ethereumex.Counter.increment/3","type":"function"},{"doc":"","ref":"Ethereumex.Counter.html#setup/0","title":"Ethereumex.Counter.setup/0","type":"function"}]